//********************** sx12app.c **************************
//* This file MUST be included into any application project
//* that uses sx12.dll. It provides DLL initialization.
//* Copyright (C) Sensoray 2001
//***********************************************************

/********************* IMPORTANT *********************
An option "Not using precompiled headers" must be set in project
properties for this file if it is an MFC project.
******************************************************/

//Function pointers are created here. All modules that call
//functions from sx12.dll must include sx12f.h

#define XFUNCX12(RTNTYPE,FUNCNAME)		RTNTYPE (__stdcall *FUNCNAME)

#include <windows.h>
#include "sx12.h"
#include "sx12f.h"

HINSTANCE hx12lib;

//Initialize pointers to exported functions.
//Return 0 if success

#define GETFPTR(FPTR,FNAM) if(((FARPROC)FPTR=GetProcAddress(hx12lib,FNAM))==NULL) return ERR_FUNCADDR;

int GetFuncPtrs(void)
{
GETFPTR (	X12_reset,		"X12_reset");
GETFPTR (	X12_set_input,		"X12_set_input");
GETFPTR (	X12_set_input_type,	"X12_set_input_type");
GETFPTR (	X12_set_system,		"X12_set_system");
GETFPTR (	X12_set_bitrate,	"X12_set_bitrate");
GETFPTR (	X12_set_picsize,	"X12_set_picsize");
GETFPTR (	X12_set_m,		"X12_set_m");
GETFPTR (	X12_set_n,		"X12_set_n");
GETFPTR (	X12_set_vbr,		"X12_set_vbr");
GETFPTR (	X12_read_gpio,		"X12_read_gpio");
GETFPTR (	X12_write_gpio,		"X12_write_gpio");
GETFPTR (	X12_get_framecount,	"X12_get_framecount");
GETFPTR (	X12_get_displayframecount,"X12_get_displayframecount");
GETFPTR (	X12_get_droppedframes,	"X12_get_droppedframes");
GETFPTR (	X12_get_vqsize,		"X12_get_vqsize");
GETFPTR (	X12_get_port,		"X12_get_port");
GETFPTR (	X12_read,		"X12_read");
GETFPTR (	X12_write,		"X12_write");
GETFPTR (	X12_init,		"X12_init");
GETFPTR (	X12_cleanup,		"X12_cleanup");

return(0);
}


// DLL open/close functions

int X12_DLLOpen(void)
{
int err;

hx12lib=LoadLibrary("x12.dll");
if(hx12lib==NULL) return ERR_LOADING_DLL;
if((err=GetFuncPtrs())!=0)
  {
  FreeLibrary(hx12lib);
  return (err);
  }
return(0);
}


void X12_DLLClose(void)
{
if(hx12lib) FreeLibrary(hx12lib);
}

